﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xrm.Client;

namespace Kocic.RepositoryManagement.Crm4
{
    /// <summary>
    /// Provides a means to identify the relationship between two CRM entities
    /// </summary>
    public class XrmRelationshipInfo
    {
        /// <summary>
        /// Creates an instance of the XrmRelationshipInfo class.
        /// </summary>
        public XrmRelationshipInfo()
        {

        }

        /// <summary>
        /// Gets or sets the primary CRM entity in the relationship
        /// </summary>
        public ICrmEntity Primary
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the related CRM entity in the relationship
        /// </summary>
        public ICrmEntity Related
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the relationship name
        /// </summary>
        public string Name
        {
            get;
            set;
        }
    }
}